/* ==UserStyle==
@name           YAGPDB Custom Commands Syntax Highlighting
@namespace      github.com/openstyles/stylus
@version        1.4.4
@description    A new userstyle
@author         Me
==/UserStyle== */

@-moz-document domain("yagpdb.xyz") {
:root {
  --gutter-width: 4rem;
  --font-family: 'Fira Code', Consolas, Courier, monospace;
}

#cc-feedback-top,
#trigger-help,
#unsaved-changes-popup,
input[name="trigger"] + div,
a[href="#cc-help-modal"] {
  display: none !important;
}

.entry,
form.form-horizontal > div.row.mb-2 {
  position: relative;
}

.theme-monokai {
  --default-text-color: #f8f8f2;
  --caret-color: var(--default-text-color);
  --selection-background: #444444;
  --background-color: #222222;
  --gutter-background-color: var(--background-color);
  --ruler-color: #839496;
  --gutter-text-color: #839496;

  --braces-color: var(--default-text-color);
  --comment-color: #75715e;
  --string-color: #e6db74;
  --literal-color: #ae81ff;
  --number-color: var(--literal-color);
  --boolean-color: var(--literal-color);
  --formatter-color: var(--literal-color);
  --mention-color: var(--formatter-color);
  --builtin-color: #a6e22e;
  --variable-color: #66d9ef;
  --comparison-color: #f6aa11;
  --keyword-color: #f92672;
  --assignment-color: var(--keyword-color);
  --relationship-color: var(--keyword-color);
  --control-flow-color: var(--keyword-color);
  --operator-color: var(--keyword-color);
  --error-background-color: #f92672;
}

.theme-nord {
  --default-text-color: #d8dee9;
  --caret-color: var(--default-text-color);
  --selection-background: #434c5ecc;
  --background-color: #2e3440;
  --gutter-background-color: var(--background-color);
  --ruler-color: #434c5e;
  --gutter-text-color: #4c566ab3;

  --braces-color: #eceff4;
  --comment-color: #4c566a;
  --string-color: #a3be8c;
  --literal-color: #ebcb8b;
  --number-color: #b48ead;
  --boolean-color: #81a1c1;
  --formatter-color: var(--literal-color);
  --mention-color: var(--formatter-color);
  --builtin-color: #88c0d0;
  --variable-color: var(--default-text-color);
  --comparison-color: var(--boolean-color);
  --keyword-color: var(--boolean-color);
  --assignment-color: var(--keyword-color);
  --relationship-color: var(--keyword-color);
  --control-flow-color: var(--keyword-color);
  --operator-color: var(--keyword-color);
  --error-background-color: #bf616a;
}

.entry textarea.form-control {
  white-space: pre;
  overflow-wrap: normal;
  overflow-x: auto;
  z-index: 0;
  color: transparent;
  caret-color: var(--caret-color);
  margin-left: var(--gutter-width);
  border-radius: 0;
  border: 0;
}
.entry textarea.form-control::selection {
  background-color: var(--selection-background);
  color: transparent;
}
.entry textarea.form-control:focus {
  box-shadow: none;
}
.entry textarea.form-control:focus ~ .syntax-highlight {
  box-shadow: 0 1px 1px rgba(0, 0, 0, 0.075) inset, 0 0 8px rgba(0, 136, 204, 0.3);
}

.entry textarea.form-control,
.entry textarea.form-control ~ .syntax-highlight {
  background-color: var(--background-color);
  font-family: var(--font-family);
  font-size: 10pt !important;
  line-height: 1.1 !important;
  padding: 0.25rem 0;
  padding-left: 0;
}

.entry textarea.form-control ~ .syntax-highlight {
  position: absolute;
  max-height: 100%;
  min-height: 100%;
  overflow: hidden;
  color: var(--default-text-color);
  margin-bottom: 0;
  z-index: 100;
  flex: 1 1 auto;
  background-color: transparent;
  width: calc(100% - 30px);
  white-space: pre;
  border-radius: 0.2rem;
  pointer-events: none;
}

span.menu {
  pointer-events: all;
  display: inline-block;
  position: absolute;
  top: 0;
  right: 0;
  margin: 0 1rem;
  font-family: var(--font-family);
  color: var(--default-text-color);
  z-index: 2;
}

span.menu .editor-options-menu-header {
  margin: 0;
  padding: 0.25rem 0.5rem;
  background-color: var(--comment-color);
}

span.menu .editor-options-menu-header i.fa-cog {
  margin-left: 0.5rem;
}

span.menu .editor-options-menu-header:not(.open):hover i.fa-cog,
span.menu .editor-options-menu-header.open:not(:hover) i.fa-cog {
  color: var(--variable-color);
  rotate: 90deg;
}

span.menu > menu {
  position: absolute;
  right: 0;
  list-style-type: none;
  padding: 0.25rem 0.5rem;
  background-color: var(--comment-color);
  margin: 0;
  min-width: 20rem;
}

span.menu > menu li:last-child label {
  margin-bottom: 0;
}

span.menu > menu input[type="checkbox"],
span.menu > menu input[type="radio"] {
  margin-right: 0.5rem;
}

span.menu > menu input:not([type="checkbox"]),
span.menu > menu select {
  margin-left: 0.5rem;
}

span.menu > menu input[type="text"],
span.menu > menu textarea,
span.menu > menu select {
  background-color: var(--background-color);
  color: var(--default-text-color);
  border: 0;
  padding: 0.25rem 0.5rem;
  border-radius: 0.2rem;
}

.entry textarea.form-control ~ .syntax-highlight .gutter {
  position: absolute;
  left: 0;
  top: 0;
  padding: 0.25rem 0.5rem;
  background-color: var(--gutter-background-color);
  color: var(--gutter-text-color);
  width: var(--gutter-width);
  min-height: 100%;
  text-align: right;
}
.entry textarea.form-control ~ .syntax-highlight .gutter .lineNo {
  display: block;
}

.entry textarea.form-control ~ .syntax-highlight .content {
  margin-left: var(--gutter-width);
  overflow-x: hidden;
}

.entry textarea.form-control ~ .syntax-highlight .ruler {
  position: absolute;
  margin-left: var(--gutter-width);
  border-left: 1px dotted var(--ruler-color);
  height: 100%;
  top: 0;
  /* left determined by .syntax-highlight constructor when adding rulers */
}

.braces, .paren {
  color: var(--braces-color);
}

.comment {
  color: var(--comment-color);
}

.string {
  color: var(--string-color);
}

.number {
  color: var(--number-color);
}

.bool {
  color: var(--boolean-color);
}

.lit {
  color: var(--literal-color);
}

.formatter {
  color: var(--formatter-color);
}

.builtin {
  color: var(--builtin-color);
}

.var {
  color: var(--variable-color);
}

.comp {
  color: var(--comparison-color);
}

.mention {
  color: var(--mention-color);
}

.assign {
  color: var(--assignment-color);
}

.rel {
  color: var(--relationship-color);
}

.control {
  color: var(--control-flow-color);
}

.keyword {
  color: var(--keyword-color);
}

.op {
  color: var(--operator-color);
}

.error {
  background-color: var(--error-background-color);
}
}
